Unit sfa5e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function sfa5e(N :Integer; A :Extended): Extended;

implementation

function sfa5e(N :Integer; A :Extended): Extended;
var
K,M :Integer;
DA,R,DR,S,A2 :Extended;
const
ZERO :Real = 0.0e0;
TWO :Real = 2.0e0;
ONE :Real = 1.0e0;
SYS051 :Real = 1.1107652e-16;
label
_10,_20,_11,_12,_13,_25,_30,_40,_50;
begin
{ Result -    SFA5E  FORTRANe }
if ( A <> ZERO ) 
 then goto _20;
if ( (N div 2)*2 = N ) 
 then goto _10;
Result := ZERO;
goto _50;
_10:
Result := TWO/(N+1);
goto _50;
_20:
DA := ONE/A;
R := Exp(A);
DR := ONE/R;
S := (R-DR)*DA;
if ( N = 0 ) 
 then goto _40;
if ( Abs(A) > ONE ) 
 then goto _25;
A2 := A*A;
if ( (N div 2)*2 = N ) 
 then goto _11;
S := TWO*A/(N+2);
R := S;
K := 1;
goto _12;
_11:
S := TWO/(N+1);
R := S;
K := 0;
_12:
K := K+2;
R := R*A2*(N+K-1)/(K*(K-1)*(N+1+K));
S := S+R;
if ( Abs(R) > SYS051 ) 
 then goto _12;
if ( (N div 2)*2 = N ) 
 then goto _13;
Result := -(S+R);
goto _50;
_13:
Result := S+R;
goto _50;
_25:
K := -1;
for M:=1 to N do
 begin
  S := (K*R-DR+M*S)*DA;
  K := -K;
_30:
 end;
_40:
Result := S;
_50:
exit;
end;

end.
